#
# Jonas Pohlandt, 2002

use LWP::UserAgent; #fr die HTTP Methode POST 
use HTML::Entities; #zur Umwandlung vom HTML Entities wie &uuml; in Unocode characters

$ua = LWP::UserAgent->new;

my $servletpath = 'http://127.0.0.1:8080/servlet/BibSearchServlet';
my $reqstring = 'requester=cli';
my $i = 0;
my $paramter;
if (@ARGV == 0) {
	die("\nUsage: perl BibSearchCLI.pl [-i] tag=value[(&|#)value[(&|#)value ... ]] [tag= ...]\n" .
	       "Beispiel: perl BibSearchCLI.pl author=Fischer#Strauss year=2000 title=informatik&beispiel\n")
}

while ($i < @ARGV) {
	if (($ARGV[$i] =~ /(-i|[a-zA-Z]+(<|>|=)\S+((\#|&)\S+)*)/) != 1) {
	   die("\nUsage: perl BibSearchCLI.pl [-i] tag=value[(&|#)value[(&|#)value ... ]] [tag= ...]\n" .
	       "Beispiel: perl BibSearchCLI.pl author=Fischer#Strauss year=2000 title=informatik&beispiel\n"); 
	}
	
	$ARGV[$i] =~ m/(\w+)=/;
	$parameter = $1;
	
	if ($ARGV[$i] eq '-i') {
	   $reqstring = 'csbool=on&' . $reqstring;
	}
	
	if ($ARGV[$i] =~ m/(\w+)=\d+/g) {
	   $reqstring = $1 . 'bool=%3D&' . $reqstring;
	}
	if ($ARGV[$i] =~ m/(\w+)>\d+/g) {
	   $reqstring = $1 . 'bool=%3E&' . $reqstring;
	}
	if ($ARGV[$i] =~ m/(\w+)<\d+/g) {
	   $reqstring = $1 . 'bool=%3C&' . $reqstring;
	}
	if ($ARGV[$i] =~ m/(\w+)<=\d+/g) {
	   $reqstring = $1 . 'bool=%3C%3D&' . $reqstring;
	}
	if ($ARGV[$i] =~ m/(\w+)>=\d+/g) {
	   $reqstring = $1 . 'bool=%3E%3C&' . $reqstring;
	}

	
	$ARGV[$i] =~ s/(<|>)/=/g;
	$ARGV[$i] =~ s/==/=/g;
	
	if ($ARGV[$i] =~ m/\#/) {
	    $reqstring = $parameter . 'bool=ODER&' . $reqstring;
	} else {
	    $reqstring = $parameter . 'bool=UND&' . $reqstring;
	}
	$ARGV[$i] =~ s/\#/ /g;
	$ARGV[$i] =~ s/&/ /g;
	$reqstring = $ARGV[$i] . '&' . $reqstring;
	$i = $i + 1;
}

#debug
#print "***\n$reqstring\n***\n";

my $req = HTTP::Request->new(POST => $servletpath);
$req->content_type('application/x-www-form-urlencoded');

$req->content($reqstring);
my $res = $ua->request($req);
my $outputstring = $res->as_string;
decode_entities($outputstring);

print $outputstring;